# -*- coding: utf-8 -*-
"""
$Id: schemata.py,v 1.3 2005/10/25 08:14:17 kayeva Exp $
"""

__author__  = 'Jerome Sandarnaud'
__docformat__ = 'restructuredtext'

# Archetypes import
from Products.Archetypes.public import *

# PloneSimpleForum schema
SimpleForumSchema = BaseSchema.copy()
SimpleForumSchema['description'].isMetadata = False
SimpleForumSchema['description'].schemata = 'default'

# PloneSimplePost schema
SimpleForumPostSchema = BaseSchema.copy() + Schema((

    IntegerField('level',
                 required=True,
                 default_method='_getDefaultLevel',
                 widget=IntegerWidget(label='Level')
    ),

    StringField('post_author',
                required=True,
                default_method='_getDefaultPostAuthor',
                widget=StringWidget(label = 'Post Author',
                                    label_msgid = 'label_post_author',
                                    i18n_domain = 'simpleforum')
    ),

    TextField('text',
              required=True,
              searchable=True,
              primary=True,
              validators = ('isTidyHtmlWithCleanup',),
              default_content_type = 'text/html',
              default_output_type = 'text/html',
              allowable_content_types = ('text/structured',
                                         'text/restructured',
                                         'text/html',
                                         'text/plain'),
              widget = RichWidget(label = "Post Text",
                                  label_msgid = "label_post_text",
                                  rows = 15,
                                  i18n_domain = "simpleforum")),
    ), marshall=RFC822Marshaller()
)

SimpleForumPostSchema['id'].widget.visible = {'view': 'invisible',
                                              'edit': 'invisible'}
SimpleForumPostSchema['level'].widget.visible = {'view': 'invisible',
                                                 'edit': 'invisible'}
SimpleForumPostSchema['text'].default_content_type = 'text/html'
SimpleForumPostSchema['text'].widget.allow_file_upload = 0
SimpleForumPostSchema['text'].widget.allow_format_edit = 0
